# -*- coding: utf-8 -*-

import os
import sys
import timeit
import inspect
import imp
from os.path import join


__all__ = ['__version__', 'run_tymer', 'skip', 't']

__version__ = "0.2"


def run_tymer():
    print "=================================================="
    print "tymer %s" % __version__

    tests = []
    if len(sys.argv) > 1:
        filename = sys.argv[1]
        tests.append(filename)
    else:
        cwd = os.getcwd()
        for i in os.walk(cwd):
            for f in i[2]:
                if f.startswith('tymer_') and f.endswith('.py'):
                    tests.append(join(i[0], f))
    
    for t in tests:
        mod = imp.load_source('tymer_mod', t)
        for func_name in dir(mod):
            if func_name.startswith('tymer_'):
                func = getattr(mod, func_name)
                if func.func_dict.get('tymer_skip', False):
                    print "===== skipping:", func_name[6:], "=====" 
                else:
                    print "===== running:", func_name[6:], "====="
                    func()

    print "=================================================="


def _get_caller_module(mod_name):
    return inspect.getmodule(mod_name)


def skip(func):
    def inner(): pass
    inner.func_dict['tymer_skip'] = True
    return inner


def t(code):
    mod_name = inspect.stack()[1][0]
    mod = _get_caller_module(mod_name)
    for line in code.split('\n'):
        print ">", line.rstrip()
    try:
        setup = getattr(mod, 'setup_tymer')
    except:
        setup = "pass"
    print "Result:", timeit.Timer(code, setup).timeit()
